from dataclasses import dataclass

from ..result import Result, Success, Failure
from ..transformer import Transformer


@dataclass
class EndTransform(Transformer[None]):
    def __init__(self) -> None:
        pass
    
    def parse(self, stream: str, at_index: int) -> Result[None]:
        if len(stream) == at_index:
            return Success(None, at_index)
        return Failure(at_index, set("<end>"))
