from dataclasses import dataclass
from typing import TypeVar

from ..result import Result
from ..transformer import Transformer

from .map import MapTransform


I = TypeVar("I")
T = TypeVar("T")
@dataclass
class ValueTransform(Transformer[T]):
    def __init__(self, ignored: Transformer[I], value: T):
        self.actual = MapTransform(ignored, lambda _: value)

    def parse(self, stream: str, at_index: int) -> Result[T]:
        return self.actual.parse(stream, at_index)
